import { world, system } from "@minecraft/server";


class loreItem {
    constructor(itemId, lore) {
        this.itemId = itemId;
        this.lore = lore;
    }
}
const ItemArray = [
    new loreItem("jjk:diamond_minecart", ["HEY EVERYONE DAN HERE FROM THE DIAMOND MINECART"]),
    new loreItem("jjk:bounty_poster", ["Trade to a hooded figure."]),
    new loreItem("jjk:bounty_proof", ["Trade to a hooded figure."]),
    new loreItem("jjk:boss_core", ["Trade to a hooded figure."]),

    new loreItem("jjk:bounty_dantdm", ["Use in a wide open space."]),



    new loreItem("jjk:cleave", ["Slice enemies in a 10 block radius."]),
    new loreItem("jjk:dismantle", ["Cut through the terrain."]),
    new loreItem("jjk:open", ["A devastating attack."]),
    new loreItem("jjk:reversed_cursed_technique_sukuna", ["Heal your injuries."]),
    new loreItem("jjk:malevolent_shrine", ["Domain Expansion, works similarly to cleave."]),
    new loreItem("jjk:sukuna_finger", ["Gain Shrine and eat more for more buffs."]),

    new loreItem("jjk:red", ["A destructive ability."]),
    new loreItem("jjk:blue", ["Pull in foes, but don't get too close."]),
    new loreItem("jjk:reversed_cursed_technique_gojo", ["Heal your injuries."]),
    new loreItem("jjk:hollow_purple", ["A devastating technique."]),
    new loreItem("jjk:infinite_void", ["Domain Expansion, stuns enemies."]),
    new loreItem("jjk:six_eye", ["Use to gain Limitless."]),

];
system.runInterval(() => {
    for (const player of world.getPlayers()) {
        const playerContainer = player.getComponent("inventory").container
        for (let i = 0; i < playerContainer.size; i++) {
            const item = playerContainer.getItem(i);
            const findLore = ItemArray.find(x => x.itemId == item?.typeId);
            const lore = item?.getLore();
            if (!findLore || !item || lore?.length != 0) continue
            item.setLore(findLore.lore);
            playerContainer.setItem(i, item);
         }
        }
    } 
)

system.runInterval(() => {
    for (const player of world.getPlayers()) {
        if(player.hasTag('ct_sukuna') && player.hasTag('bv_reveal_hand') ){
            player.nameTag = player.name + "\nSHRINE"
        };
        if(player.hasTag('ct_gojo') && player.hasTag('bv_reveal_hand')){
            player.nameTag = player.name + "\nLIMITLESS"
        };
        if(player.hasTag('ct_megumi') && player.hasTag('bv_reveal_hand')){
            player.nameTag = player.name + "\nTEN SHADOWS"
        };
        }
    } 
)

world.afterEvents.playerSpawn.subscribe(({ player }) => {
    player.runCommandAsync("tag @s remove cleaved")
    player.runCommandAsync("tag @s remove diamond_cut")
    player.runCommandAsync("tag @s remove diamond_storm")
    player.runCommandAsync("tag @s remove shrined")
    player.runCommandAsync("tag @s remove voided")
    player.runCommandAsync("gamerule sendcommandfeedback false")
});


world.afterEvents.playerSpawn.subscribe(({ player, initialSpawn }) => {
    if (!initialSpawn || player.getDynamicProperty("hasJoinedBefore")) return;
    player.sendMessage("Welcome to Kaisen Craft!");
    player.runCommandAsync("gamerule sendcommandfeedback false")
    player.setDynamicProperty("hasJoinedBefore", true);
  }); 


world.afterEvents.itemUse.subscribe((data) => {
    const player = data.source
    const item = data.itemStack
    const cooldown = item.getComponent("minecraft:cooldown")
    if (item.typeId === "jjk:bounty_dantdm" && item.getComponent("minecraft:cooldown") && player.getItemCooldown("bounty") === cooldown.cooldownTicks - 1) {
        player.runCommandAsync("structure load dantdm_structure ^ ^ ^ 0_degrees")
        cooldown.startCooldown(player)
    }
    if (item.typeId === "jjk:sukuna_finger" && item.getComponent("minecraft:cooldown") && player.getItemCooldown("sukuna_finger") === cooldown.cooldownTicks - 1) {
        player.runCommandAsync("clear @s jjk:sukuna_finger 0 1")
        player.runCommandAsync("tag @s add ct_on")
        player.runCommandAsync("scoreboard objectives add fingers_consumed dummy fingers_consumed")
        player.runCommandAsync("scoreboard players add @s fingers_consumed 1")
        player.runCommandAsync("scoreboard players set @s[scores={fingers_consumed=21}] fingers_consumed 20")
        player.runCommandAsync("playsound mob.wither.death")
        player.runCommandAsync("scoreboard players set @s[tag=ct_gojo] fingers_consumed 0")
        player.runCommandAsync("scoreboard players set @s[tag=ct_megumi] fingers_consumed 0")
        player.runCommandAsync("scoreboard players set @s[tag=ct_jogo] fingers_consumed 0")
        player.runCommandAsync("scoreboard players set @s[tag=ct_itadori] fingers_consumed 0")


        player.runCommandAsync("tag @s[tag=ct_gojo] remove ct_sukuna")
        player.runCommandAsync("tag @s[tag=ct_megumi] remove ct_sukuna")
        player.runCommandAsync("tag @s[tag=ct_jogo] remove ct_sukuna")
        player.runCommandAsync("tag @s[tag=ct_itadori] remove ct_sukuna")

        player.runCommandAsync("kill @s[tag=ct_gojo]")
        player.runCommandAsync("kill @s[tag=ct_megumi]")
        player.runCommandAsync("kill @s[tag=ct_jogo]")
        player.runCommandAsync("kill @s[tag=ct_itadori]")




        player.runCommand("function items/sukuna/sukuna_ct_on")
        cooldown.startCooldown(player)
    }
    if (item.typeId === "jjk:six_eye" && item.getComponent("minecraft:cooldown") && player.getItemCooldown("sukuna_finger") === cooldown.cooldownTicks - 1) {
        player.runCommandAsync("tag @s add ct_gojo")
        player.runCommandAsync("tag @s add ct_on")
        player.runCommandAsync("playsound mob.enderdragon.growl")
        player.runCommandAsync("clear @s jjk:six_eye 0 1")
        
        player.runCommandAsync("tag @s[tag=ct_sukuna] remove ct_gojo")
        player.runCommandAsync("tag @s[tag=ct_megumi] remove ct_gojo")
        player.runCommandAsync("tag @s[tag=ct_jogo] remove ct_gojo")
        player.runCommandAsync("tag @s[tag=ct_itadori] remove ct_gojo")

        player.runCommandAsync("kill @s[tag=ct_sukuna]")
        player.runCommandAsync("kill @s[tag=ct_megumi]")
        player.runCommandAsync("kill @s[tag=ct_jogo]")
        player.runCommandAsync("kill @s[tag=ct_itadori]")




        player.runCommand("function items/gojo/gojo_ct_on")
        cooldown.startCooldown(player)
    }
    if (item.typeId === "jjk:cleave" && item.getComponent("minecraft:cooldown") && player.getItemCooldown("cleave") === cooldown.cooldownTicks - 1) {
        player.runCommandAsync("summon jjk:cleave_dummy ~ ~ ~ ~ ~ jjk:cleave_dummy")
        player.runCommandAsync("tag @e[r=10] add cleaved")
        player.runCommandAsync("tag @s remove cleaved")
        player.runCommandAsync("execute if entity @e[tag=cleaved] at @e[tag=cleaved] run playsound sukuna.cleave @a[r=10]")
        cooldown.startCooldown(player)
        
    }
    if (item.typeId === "jjk:dismantle" && item.getComponent("minecraft:cooldown") && player.getItemCooldown("dismantle") === cooldown.cooldownTicks - 1) {
        player.runCommandAsync("playsound sukuna.dismantle @a[r=15]")
        const entity = player.dimension.spawnEntity('jjk:dismantle_projectile', player.getHeadLocation());
        const projectile = entity.getComponent('projectile');
        projectile.owner = player;
        projectile.shoot(player.getViewDirection())
        cooldown.startCooldown(player)
    }
    if (item.typeId === "jjk:reversed_cursed_technique_sukuna" && item.getComponent("minecraft:cooldown") && player.getItemCooldown("rct") === cooldown.cooldownTicks - 1) {
        player.runCommandAsync("effect @s regeneration 3 6")
        player.runCommandAsync("effect @s absorption 59 1")
        cooldown.startCooldown(player)
        
    }
    if (item.typeId === "jjk:malevolent_shrine" && item.getComponent("minecraft:cooldown") && player.getItemCooldown("shrine") === cooldown.cooldownTicks - 1) {
        player.runCommandAsync("playsound sukuna.domain @a[r=20]")

        player.runCommandAsync("summon jjk:malevolent_shrine ^ ^ ^-7 ~ ~")
        player.runCommandAsync("playanimation @e[type=jjk:malevolent_shrine, r=8.5] spawn")
        player.runCommandAsync("effect @e[r=25] darkness 15 0 true") 
        player.runCommandAsync("summon jjk:cleave_dummy ~ ~ ~ ~ ~ jjk:shrine_dummy")
        player.runCommandAsync("tag @e[r=25] add shrined")
        player.runCommandAsync("tag @s remove shrined")
        player.runCommandAsync("execute if entity @e[tag=shrined] at @e[tag=shrined] run playsound sukuna.cleave @a[r=20]")
        cooldown.startCooldown(player)

    }
    if (item.typeId === "jjk:open" && item.getComponent("minecraft:cooldown") && player.getItemCooldown("open") === cooldown.cooldownTicks - 1) {
        player.runCommandAsync("playsound sukuna.fuga @a[r=15]")
        const entity = player.dimension.spawnEntity('jjk:open_projectile', player.getHeadLocation());
        const projectile = entity.getComponent('projectile');
        projectile.owner = player;
        projectile.shoot(player.getViewDirection())
        cooldown.startCooldown(player)
    }
    if (item.typeId === "jjk:sukuna_cursed_technique_on" && item.getComponent("minecraft:cooldown") && player.getItemCooldown("ct_enable") === cooldown.cooldownTicks - 1) {
        player.runCommandAsync("tag @s remove ct_on")
        player.runCommandAsync("tag @s remove ct_off")
        player.runCommandAsync("tag @s add ct_on")
        player.runCommand("function items/sukuna/sukuna_ct_on")
        cooldown.startCooldown(player)
        
    }
    if (item.typeId === "jjk:sukuna_cursed_technique_off" && item.getComponent("minecraft:cooldown") && player.getItemCooldown("ct_enable") === cooldown.cooldownTicks - 1) {
        player.runCommandAsync("tag @s remove ct_on")
        player.runCommandAsync("tag @s remove ct_off")
        player.runCommandAsync("tag @s add ct_off")
        player.runCommand("function items/sukuna/sukuna_ct_off")
        cooldown.startCooldown(player)
        
    }
    if (item.typeId === "jjk:red" && item.getComponent("minecraft:cooldown") && player.getItemCooldown("red") === cooldown.cooldownTicks - 1) {
        player.runCommandAsync("playsound gojo.red @a[r=15]")
        const entity = player.dimension.spawnEntity('jjk:red_projectile', player.getHeadLocation());
        const projectile = entity.getComponent('projectile');
        projectile.owner = player;
        projectile.shoot(player.getViewDirection())
        cooldown.startCooldown(player)
    }
    if (item.typeId === "jjk:blue" && item.getComponent("minecraft:cooldown") && player.getItemCooldown("blue") === cooldown.cooldownTicks - 1) {
        player.runCommandAsync("playsound gojo.blue @a[r=15]")
        const entity = player.dimension.spawnEntity('jjk:blue_projectile', player.getHeadLocation());
        const projectile = entity.getComponent('projectile');
        projectile.owner = player;
        projectile.shoot(player.getViewDirection())
        cooldown.startCooldown(player)
    }
    if (item.typeId === "jjk:hollow_purple" && item.getComponent("minecraft:cooldown") && player.getItemCooldown("purple") === cooldown.cooldownTicks - 1) {
        player.runCommandAsync("playsound gojo.hollow_purple @a[r=15]")
        const entity = player.dimension.spawnEntity('jjk:hollow_purple_projectile', player.getHeadLocation());
        const projectile = entity.getComponent('projectile');
        projectile.owner = player;
        projectile.shoot(player.getViewDirection())
        cooldown.startCooldown(player)
    }
    if (item.typeId === "jjk:infinite_void" && item.getComponent("minecraft:cooldown") && player.getItemCooldown("infinite_void") === cooldown.cooldownTicks - 1) {
        player.runCommandAsync("summon jjk:domain_dome")
        player.runCommandAsync("summon jjk:cleave_dummy ^ ^ ^-7 ~ ~ jjk:infinite_void_dummy")
        player.runCommandAsync("playsound gojo.domain @a[r=20]")
        player.runCommandAsync("particle jjk:void_particle_user")
        player.runCommandAsync("particle jjk:void_particle_user")
        player.runCommandAsync("effect @e[r=25] darkness 15 0 true")
        player.runCommandAsync("tag @e[r=25] add voided")
        player.runCommandAsync("tag @s remove voided")
        cooldown.startCooldown(player)
    }
    if (item.typeId === "jjk:reversed_cursed_technique_gojo" && item.getComponent("minecraft:cooldown") && player.getItemCooldown("rct") === cooldown.cooldownTicks - 1) {
        player.runCommandAsync("effect @s regeneration 3 6")
        player.runCommandAsync("effect @s absorption 59 1")
        cooldown.startCooldown(player)
        
    }
    if (item.typeId === "jjk:gojo_cursed_technique_on" && item.getComponent("minecraft:cooldown") && player.getItemCooldown("ct_enable") === cooldown.cooldownTicks - 1) {
        player.runCommandAsync("tag @s remove ct_on")
        player.runCommandAsync("tag @s remove ct_off")
        player.runCommandAsync("tag @s add ct_on")
        player.runCommand("function items/gojo/gojo_ct_on")
        cooldown.startCooldown(player)
        
    }
    if (item.typeId === "jjk:gojo_cursed_technique_off" && item.getComponent("minecraft:cooldown") && player.getItemCooldown("ct_enable") === cooldown.cooldownTicks - 1) {
        player.runCommandAsync("tag @s remove ct_on")
        player.runCommandAsync("tag @s remove ct_off")
        player.runCommandAsync("tag @s add ct_off")
        player.runCommand("function items/gojo/gojo_ct_off")
        cooldown.startCooldown(player)
        
    }
}) 

